#property copyright"おじさん＆はるちゃん"
#property link"https://f-35c.com/"
#property description "ma_rsi_atr"
#property version "1.02"
#property strict

input double Lot_Buy1=0.1;//Buy1注文 単利ロット
input int Slip_Buy1=50;//Buy1注文 スリップ
input double sl=50;//Buy1注文 SL
input double tp=50;//Buy1注文 TP
input int MagicNumber_Buy1=019001;//Buy1注文 マジックナンバー
input double Spread_Buy1=70;//Buy1注文 スプレッド回避幅
input double sls=50;//Sell1注文 SL
input double tps=50;//Sell1注文 TP
input int MagicNumber_Sell1=10001;//Sell1注文 マジックナンバー
datetime Buy1_FlagD;
datetime Sell1_FlagD;
ENUM_TIMEFRAMES Buy1_timing=PERIOD_M5;//Buy1 注文条件処理タイミング
static datetime Buy1_dt=0;
ENUM_TIMEFRAMES Sell1_timing=PERIOD_M5;//Sell1 注文条件処理タイミング
static datetime Sell1_dt=0;
ENUM_TIMEFRAMES Sell1_timing2=PERIOD_M5;//Sell1 決済条件処理タイミング
static datetime Sell1_dt2=0;

int OnInit(){
 return(INIT_SUCCEEDED);
}

void OnDeinit(const int reason){
}

void OnTick(){
 //決済に関する内容

 if(OrdersTotal()>0){
//ロング1の決済条件 
  if(iMA(NULL,PERIOD_CURRENT,20,0,MODE_SMA,PRICE_CLOSE,0) < iMA(NULL,PERIOD_CURRENT,50,0,MODE_SMA,PRICE_CLOSE,0) &&
    iRSI(NULL,PERIOD_CURRENT,14,PRICE_CLOSE,0) < 50){
    LimitPriceDelete(MagicNumber_Buy1);
    ExitOrder(OP_BUY,"0",50,70,"",MagicNumber_Buy1);
  }
 }
 if(NewCandle(Sell1_dt2,Sell1_timing2) && OrdersTotal()>0){
//ショート1の決済条件 
  if(iMA(NULL,PERIOD_CURRENT,20,0,MODE_SMA,PRICE_CLOSE,0) > iMA(NULL,PERIOD_CURRENT,50,0,MODE_SMA,PRICE_CLOSE,0) &&
    iRSI(NULL,PERIOD_CURRENT,14,PRICE_CLOSE,0) > 50){
    ExitOrder(OP_SELL,"0",50,70,"",MagicNumber_Sell1);
  }
 }
 //注文に関する内容

 if(NewCandle(Buy1_dt,Buy1_timing)){
//ロング1の注文条件 
  if(iMA(NULL,PERIOD_CURRENT,20,0,MODE_SMA,PRICE_CLOSE,0) > iMA(NULL,PERIOD_CURRENT,50,0,MODE_SMA,PRICE_CLOSE,0) &&
    iMA(NULL,PERIOD_CURRENT,20,0,MODE_SMA,PRICE_CLOSE,1) < iMA(NULL,PERIOD_CURRENT,50,0,MODE_SMA,PRICE_CLOSE,1) &&
    iRSI(NULL,PERIOD_CURRENT,14,PRICE_CLOSE,0) > 50 &&
    iATR(NULL,PERIOD_CURRENT,20,0) > 0.05 && Buy1_FlagD != iTime(NULL,PERIOD_CURRENT,0)){
    Buy1_FlagD = iTime(NULL,PERIOD_CURRENT,0);
    EntryOrder(OP_BUY,Lot_Buy1,Ask+0*10*Point(),Slip_Buy1,sl,tp,"",MagicNumber_Buy1,Spread_Buy1);
  }
 }
 if(NewCandle(Sell1_dt,Sell1_timing)){
//ショート1の注文条件 
  if(iMA(NULL,PERIOD_CURRENT,20,0,MODE_SMA,PRICE_CLOSE,0) < iMA(NULL,PERIOD_CURRENT,50,0,MODE_SMA,PRICE_CLOSE,0) &&
    iMA(NULL,PERIOD_CURRENT,20,0,MODE_SMA,PRICE_CLOSE,1) > iMA(NULL,PERIOD_CURRENT,50,0,MODE_SMA,PRICE_CLOSE,1) &&
    iRSI(NULL,PERIOD_CURRENT,14,PRICE_CLOSE,0) < 50 &&
    iATR(NULL,PERIOD_CURRENT,20,0) > 0.05 && Sell1_FlagD != iTime(NULL,PERIOD_CURRENT,0)){
    Sell1_FlagD = iTime(NULL,PERIOD_CURRENT,0);
    EntryOrder(OP_SELL,Lot_Buy1,Bid-0*10*Point(),Slip_Buy1,sls,tps,"",MagicNumber_Sell1,Spread_Buy1);
  }
 }
}

 //エントリーに関する関数
int EntryOrder(ENUM_ORDER_TYPE dir, double lot,double price,int slip,double in_Sl,double in_Tp, string comment, int magic,double spread){
 if(dir==-1)return 0;
 if(Ask - Bid >= spread * Point())return 0;
 int order_type=0; // 注文タイプ
 double stoplevel=MarketInfo(Symbol(),MODE_STOPLEVEL); // オーダープライスレート
 double order_rate=0; // オーダープライスレート
 double stoploss=0;
 double takeprofit=0;

 if(dir==OP_BUY){    // 成り行き注文
  order_type = OP_BUY; // 注文タイプ
  order_rate=Ask; // オーダープライスレート
  stoploss = (in_Sl == 0) ? (0) : (NormalizeDouble(Ask - in_Sl * Point * 10, _Digits));
  takeprofit = in_Tp == 0 ? 0 : NormalizeDouble(Ask + in_Tp * Point * 10, _Digits);
 }
 else if(dir==OP_SELL){
  order_type = OP_SELL;
  order_rate = Bid;
  stoploss = in_Sl == 0 ? 0 : NormalizeDouble(Bid + in_Sl * Point * 10, _Digits);
  takeprofit = in_Tp == 0 ? 0 : NormalizeDouble(Bid - in_Tp * Point * 10, _Digits);
 }
 else if(dir==OP_BUYLIMIT){ // 指値注文 
  order_type = OP_BUYLIMIT;
  order_rate = price;
  //---ストップレベルの回避（OrderSend Error 130を回避）
  if(Ask - order_rate <= 0){    //成り行きエントリー
     order_type = OP_BUY;   // 成り行き注文
     order_rate = Ask;
  }
  else if(Ask - order_rate <= stoplevel){    //注文レートが近すぎた場合その分少し離す
   order_rate = Ask - (stoplevel+Point);
  }
  stoploss = in_Sl == 0 ? 0 : NormalizeDouble(order_rate + in_Sl * Point * 10, _Digits);
  takeprofit = in_Tp == 0 ? 0 : NormalizeDouble(order_rate - in_Tp * Point * 10, _Digits);
 }
 else if(dir==OP_SELLLIMIT){ // 指値注文 
  order_type = OP_SELLLIMIT;
  order_rate = price;
  //---ストップレベルの回避（OrderSend Error 130を回避）
  if(order_rate - Bid <= 0 <= 0){    //成り行きエントリー
     order_type = OP_SELL;   // 成り行き注文
     order_rate = Bid;
  }
  else if(order_rate - Bid <= stoplevel){    //注文レートが近すぎた場合その分少し離す
   order_rate = Bid + (stoplevel+Point);
  }
  stoploss = in_Sl == 0 ? 0 : NormalizeDouble(order_rate + in_Sl * Point * 10, _Digits);
  takeprofit = in_Tp == 0 ? 0 : NormalizeDouble(order_rate - in_Tp * Point * 10, _Digits);
 }
 else if(dir==OP_BUYSTOP){  // 逆指値注文
  order_type = OP_BUYSTOP;
  order_rate = price;
  //---ストップレベルの回避（OrderSend Error 130を回避）
  if(order_rate - Ask <= 0){    //成り行きエントリー
    order_type = OP_BUY;   // 成り行き注文
    order_rate = Ask;
  }
  else if(order_rate - Ask <= stoplevel){    //注文レートが近すぎた場合その分少し離す
   order_rate = Ask + (stoplevel+Point);
  }
  stoploss = (in_Sl == 0) ? (0) : (NormalizeDouble(order_rate - in_Sl * Point * 10, _Digits));
  takeprofit = in_Tp == 0 ? 0 : NormalizeDouble(order_rate + in_Tp * Point * 10, _Digits);
 }
 else if(dir==OP_SELLSTOP){
  order_type = OP_SELLSTOP;
  order_rate = price;
  //---ストップレベルの回避（OrderSend Error 130を回避）
  if(Bid - order_rate <= 0){    //成り行きエントリー
   order_type = OP_SELL;   // 成り行き注文
   order_rate = Bid;
  }
  else if(Bid - order_rate <= stoplevel){   //注文レートが近すぎた場合その分少し離す
   order_rate = Bid - (stoplevel+Point);
  }
  stoploss = in_Sl == 0 ? 0 : NormalizeDouble(order_rate + in_Sl * Point * 10, _Digits);
  takeprofit = in_Tp == 0 ? 0 : NormalizeDouble(order_rate - in_Tp * Point * 10, _Digits);
 }

 double Lot=lot;
 double max_lot = MarketInfo(Symbol(), MODE_MAXLOT);
 int quot = (int)MathFloor(Lot / max_lot); //商
 double lotstep = MarketInfo(Symbol(), MODE_LOTSTEP);//ロット数の単位
 double divis_lot = NormalizeDouble(Lot - (quot * max_lot), (int)MathAbs(MathLog10(lotstep)));//除数

 for(int i = 0; i < quot; i++) { //最大ロットの注文回数分　ループ
  int ticket = OrderSend(NULL, order_type, max_lot, NormalizeDouble(order_rate,Digits()), slip, NormalizeDouble(stoploss,Digits()), NormalizeDouble(takeprofit,Digits()), comment, magic); //エントリー
  if(ticket <= 0) {
    int err = GetLastError();
    if(err != 0)Print("OrderSend Error:"+IntegerToString(err));
    return 0;
  }
 }
 //--- 最大ロットの除数分をエントリー
 int ticket = OrderSend(NULL, order_type, NormalizeDouble(divis_lot,2), NormalizeDouble(order_rate,Digits()), slip, NormalizeDouble(stoploss,Digits()), NormalizeDouble(takeprofit,Digits()), comment, magic); //エントリー
 if(ticket <= 0) {
    int err = GetLastError();
    if(err != 0)Print("OrderSend Error:"+IntegerToString(err));
  return 0;
 }
 return ticket;
}

 //決済に関する関数
bool ExitOrder(int type,string lot,int slip,double spread,string comment, int magic){
 if(Ask - Bid >= spread * Point())return false;
 bool res;
 double Lot;
 for(int i = OrdersTotal() - 1; i >= 0; i--){
   res = OrderSelect(i, SELECT_BY_POS);
   if(OrderMagicNumber() == magic && OrderSymbol() == Symbol() && OrderCloseTime()==0 && OrderType()==type){
     if(StrToDouble(lot)==0)Lot=OrderLots();
     else if(lot=="#")Lot=OrderLots()/2;
     else Lot=StrToDouble(lot);

     if(Lot<MarketInfo(Symbol(),MODE_MINLOT))Lot=MarketInfo(Symbol(),MODE_MINLOT);
     else if(Lot>OrderLots())Lot=OrderLots();

     res = OrderClose(OrderTicket(),Lot, OrderClosePrice(), slip, clrNONE);
   }
   if(!res)return res;
 }
 return true;
}

//指値削除関数
void LimitPriceDelete(int magic){
 bool res;
 for(int i = OrdersTotal() - 1; i >= 0; i--){
   res = OrderSelect(i,SELECT_BY_POS);
   if(OrderSymbol() != Symbol() || OrderMagicNumber() != magic)continue;
   res = OrderDelete(OrderTicket(),clrYellowGreen);
   if(!res){
     PrintFormat("OrderSend error %d",GetLastError());
   }
 }
}

 //条件で使用される関数群
bool NewCandle(datetime &dt,ENUM_TIMEFRAMES timing){
 if(iTime(NULL,timing,0) != dt){
  dt = iTime(NULL,timing,0);
  return(true);
 }
 else return(false);
}
